<?php

use App\libraries\Controller;

class Admin extends Controller
{

    public function __construct()
    {
        $this->userModel = $this->model('User');
        $this->postModel = $this->model('Post');
        $this->pageModel = $this->model('Page');
    }

    public function index()
    {

        if (!isset($_SESSION['username'])) {
            header('location: ' . PATH . '/users/login');
        }

        $data = [
            'title' => 'Admin Page',
        ];
        $this->view('admin/index', $data);
    }

    public function posts()
    {

        if (!isset($_SESSION['username'])) {
            header('location: ' . PATH . '/users/login');
        }

        if (isset($_POST['create_post_action'])) {
            $title = $_POST['title'];
            $body = $_POST['body'];
            $target = $_FILES['file']['name'];

            if (!empty($_FILES['file']['name'])) {

                $target_dir = MYROOT . "/public/img/";
                $target = $_FILES["file"]["name"];
                $target_file = $target_dir . basename($_FILES["file"]["name"]);
                $uploadOk = 1;
                // Check if file already exists
                if (file_exists($target_file)) {
                    $error = '
                    <div class="alert alert-warning alert-dismissible fade show" role="alert ">
                        <strong>Sorry, file already exists rename your file</strong>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>';
                    $uploadOk = 0;
                }

                // Check file size
                // if ($_FILES["file"]["size"] > 1000000) {
                //     $error = '
                //     <div class="alert alert-warning alert-dismissible fade show" role="alert ">
                //         <strong>Sorry, your file is too large.</strong>
                //         <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                //     </div>
                //     ';
                //     $uploadOk = 0;
                // }

                // Check if $uploadOk is set to 0 by an error
                if ($uploadOk == 0) {
                    $error = '<div class="alert alert-warning alert-dismissible fade show" role="alert ">
                        <strong>Sorry, your file was not uploaded.</strong>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>';
                    // if everything is ok, try to upload file
                } else {
                    if (move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)) {
                        if ($this->postModel->addPost($title, $body, $target)) {
                            $success = '
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                        <strong>Post created successfully</strong>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>';
                        }
                    }
                }
            } else {
                if ($this->postModel->addPost($title, $body, $target)) {
                    $success = '
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                        <strong>Post created successfully</strong>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>';
                }
            }
        }


        if (isset($_POST['delete_post_action'])) {
            $id = $_POST['id'];
            if ($this->postModel->deletePost($id)) {
                $success = '
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <strong>Post deleted successfully</strong>
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>';
            }
        }

        $data = [
            'title' => 'Posts',
            'posts' => $this->postModel->getPosts(),
            'error' => $error,
            'success' => $success,
        ];

        $this->view('admin/posts', $data);
    }

    public function reviews()
    {

        if (!isset($_SESSION['username'])) {
            header('location: ' . PATH . '/users/login');
        }

        if (isset($_POST['approve'])) {
            $id = $_POST['id'];
            if ($this->postModel->approveReview($id)) {
                $success = '
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <strong>Review approved successfully</strong>
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>';
            }
        }

        if (isset($_POST['delete_review_action'])) {
            $id = $_POST['id'];
            if ($this->postModel->deleteReview($id)) {
                $success = '
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <strong>Review deleted successfully</strong>
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>';
            }
        }

        $data = [
            'title' => 'Reviews',
            'success' => $success,
            'reviews' => $this->postModel->getReviews(),
        ];

        $this->view('admin/reviews', $data);
    }
}
