<?php

use App\libraries\Controller;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require MYROOT . '/vendor/autoload.php';
require MYROOT . '/vendor/phpmailer/src/Exception.php';
require MYROOT . '/vendor/phpmailer/src/PHPMailer.php';

class Pages extends Controller
{
    public function __construct()
    {
        $this->postModel = $this->model('Post');
    }

    public function index()
    {

        $title = 'Home';
        $posts = $this->postModel->get8Posts();
        $data = [
            'title' => $title,
            'posts' => $posts,
        ];
        $this->view('pages/index', $data);
    }

    public function error404()
    {
        $title = 'Not Found';
        $data = [
            'title' => $title,
        ];
        $this->view('pages/error404', $data);
    }

    public function events()
    {
        $title = "Events";
        $posts = $this->postModel->getPosts();

        $data = [
            'title' => $title,
            'posts' => $posts,
        ];

        $this->view("pages/events", $data);
    }


    public function about()
    {
        $title = 'About';
        $reviews = $this->postModel->getReviews();
        $data = [
            'title' => $title,
            'reviews' => $reviews,
            "success" => "",
        ];

        if (isset($_POST['add'])) {
            $review = [
                'name' => $_POST['name'],
                'comment' => $_POST['comment'],
                'rating' => $_POST['rating'],
                'status' => 0,
            ];
            $this->postModel->addReview($review);
            $data["success"] = "
            <div class='alert alert-success alert-dismissible fade show' role='alert'>
                <strong>Success!</strong> Your review has been submitted.
                <button type='button' class='close' data-dismiss='alert' aria-label='Close'>
                    <span aria-hidden='true'>&times;</span>
                </button></div>
            ";
        }
        $this->view('pages/about', $data);
    }

    public function accomodation()
    {
        $title = 'Accomodation';
        $data = [
            'title' => $title,
            'success' => "",
        ];
        // send mail from accomodation form
        if (isset($_POST['btnSubmit'])) {
            # code...
            $vname = $_POST['visitor_name'];
            $vmail = $_POST['visitor_email'];
            $vcity = $_POST['visitor_city'];
            $vcountry = $_POST['visitor_country'];
            $vphone = $_POST['visitor_phone'];
            $tadault = $_POST['total_adults'];
            $tchildren = $_POST['total_children'];
            $vcheckin = $_POST['checkin'];
            $vcheckout = $_POST['checkout'];
            $vroopref = $_POST['room_preference'];
            $vmessage = $_POST['visitor_message'];

            $mail = new PHPMailer(true);
            try {
                //Server settings
                $mail->isSMTP();                                            //Send using SMTP
                $mail->Host       = "mail.africabian.com";                     //Set the SMTP server to send through
                $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
                $mail->Username   = "webmaster@africabian.com";                 //SMTP username
                $mail->Password   = "HX,[=5Vt?l~l";                               //SMTP password
                $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
                $mail->Port       = "465";                                    //TCP port to connect to

                $mail->setFrom("noreply@africabian.com", "Africabian");
                $mail->addAddress("africabian@africabian.com", "Africabian");
                $mail->IsHTML(true);
                $subject = "Accomodation Form";
                $message =
                    "Name :" . $vname . "\n" .
                    "Email :" . $vmail . "\n" .
                    "City :" . $vcity . "\n" .
                    "Country :" . $vcountry . "\n" .
                    "Phone :" . $vphone . "\n" .
                    "Total Adults :" . $tadault . "\n" .
                    "Total Children :" . $tchildren . "\n" .
                    "Check-In :" . $vcheckin . "\n" .
                    "Check-Out :" . $vcheckout . "\n" .
                    "Room Preference :" . $vroopref . "\n" .
                    "Message :" . $vmessage . "\n" .
                    "";
                $mail->Subject = $subject;
                $mail->Body = $message;
                if ($mail->send()) {
                    $success = '
            <div class="alert alert-success alert-dismissible fade show" role="alert ">
                <strong>Thank you for your interest in our accommodation. We will get back to you shortly.</strong>
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
            ';
                }
            } catch (Exception $e) {
                $success = '
            <div class="alert alert-danger alert-dismissible fade show" role="alert ">
                <strong>Message could not be sent. Mailer Error: ' . $mail->ErrorInfo . '</strong>
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
            ';
            }
        }
        $data["success"] = $success;

        $this->view('pages/accomodation', $data);
    }

    public function airtransfer()
    {
        $title = 'Air Transfer';
        $data = [
            'title' => $title,
        ];
        $this->view('pages/airtransfer', $data);
    }

    public function company()
    {
        $title = 'Company';
        $data = [
            'title' => $title,
        ];
        $this->view('pages/company', $data);
    }

    // desert page
    public function desert()
    {
        $title = 'Desert';
        $data = [
            'title' => $title,
        ];
        $this->view('pages/desert', $data);
    }

    // gallery page
    public function gallery()
    {
        $title = 'Gallery';
        $data = [
            'title' => $title,
        ];
        $this->view('pages/gallery', $data);
    }

    // tours page
    public function tours()
    {
        $title = 'Tours';
        $data = [
            'title' => $title,
        ];
        $this->view('pages/tours', $data);
    }

    // visa page
    public function visa()
    {
        $title = 'Visa';
        $data = [
            'title' => $title,
            'success' => "",
        ];

        if (isset($_POST['btnSubmit'])) {
            $email = $_POST['email'];
            $phone = $_POST['phone'];
            $visatype = $_POST['visatype'];
            $visapurpose = $_POST['visapurpose'];
            $passport = $_POST['passport'];
            $arrive = $_POST['arrive'];
            $depart = $_POST['depart'];


            $target_dir = $uploadFolder = MYROOT . "/public/file/";

            //img
            $file_name    = $_FILES['passportFile']['name']; // get the temporary file name of the file on the server
            $tmp        = $_FILES['passportFile']['tmp_name'];  // get the name of the file
            $type        = $_FILES['passportFile']['type'];  // get type of the file
            //ext of the files
            $base = basename($file_name);
            $target_file_img = $target_dir . $file_name;
            $imageFileType_img = strtolower(pathinfo($target_file_img, PATHINFO_EXTENSION));
            if (!move_uploaded_file($tmp, $target_file_img)) {
                echo "Failed to upload file";
                exit;
            }

            //doc
            $doc_name    = $_FILES['scannedFile']['name']; // get the temporary doc name of the file on the server
            $tmp_doc        = $_FILES['scannedFile']['tmp_name'];  // get the name of the file
            $type        = $_FILES['scannedFile']['type'];  // get type of the file
            //ext of the files
            $base = basename($doc_name);
            $target_file_doc = $uploadFolder . $doc_name;
            $imageFileType_doc = strtolower(pathinfo($target_file_doc, PATHINFO_EXTENSION));
            if (!move_uploaded_file($tmp_doc, $target_file_doc)) {
                echo "Failed to upload docs";
                exit;
            }

            //$content_doc = chunk_split(base64_encode(file_get_contents($doc)));


            $mail = new PHPMailer(true);
            try {
                //Server settings
                $mail->isSMTP();                                            //Send using SMTP
                $mail->Host       = "mail.africabian.com";                     //Set the SMTP server to send through
                $mail->SMTPAuth   = true;                                   //Enable SMTP authentication
                $mail->Username   = "webmaster@africabian.com";                 //SMTP username
                $mail->Password   = "HX,[=5Vt?l~l";                               //SMTP password
                $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
                $mail->Port       = "465";                                    //TCP port to connect to

                $mail->setFrom("noreply@africabian.com", "Africabian");
                $mail->addAddress("africabian@africabian.com", "Africabian");
                // add attachment
                $mail->addAttachment($target_file_img);
                $mail->addAttachment($target_file_doc);
                $mail->IsHTML(true);
                $subject = "Accomodation Form";
                $message =
                    "Email :" . $email . "\n" .
                    "Phone :" . $phone . "\n" .
                    "Visa Type :" . $visatype . "\n" .
                    "Visa Purpose :" . $visapurpose . "\n" .
                    "Passport Expiry Date :" . $passport . "\n" .
                    "Arrive :" . $arrive . "\n" .
                    "Depart :" . $depart . "\n";
                "";
                $mail->Subject = $subject;
                $mail->Body = $message;
                if ($mail->send()) {
                    $success = '
            <div class="alert alert-success alert-dismissible fade show" role="alert ">
                <strong>Thank you for your interest in our accommodation. We will get back to you shortly.</strong>
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
            ';
                }
            } catch (Exception $e) {
                $success = '
            <div class="alert alert-danger alert-dismissible fade show" role="alert ">
                <strong>Message could not be sent. Mailer Error: ' . $mail->ErrorInfo . '</strong>
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
            ';
            }
        }

        $data['success'] = $success;
        $this->view('pages/visa', $data);
    }
}
