<?php

use App\libraries\Database;

class Post
{
    private $db;

    public function __construct()
    {
        $this->db = new Database;
    }

    public function getPosts()
    {
        $this->db->query("SELECT * FROM posts");

        $result = $this->db->resultSet();
        return $result;
    }

    public function get8Posts()
    {
        $this->db->query("SELECT * FROM posts LIMIT 8");

        $result = $this->db->resultSet();
        return $result;
    }

    public function addPost($title, $body, $target)
    {
        $this->db->query("INSERT INTO `posts`(`title`, `body`, `file`, `created_at`, `updated_at`) VALUES ('$title','$body','$target',NOW(),NOW())");

        // Execute
        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function getPostById($id)
    {
        $this->db->query("SELECT * FROM posts WHERE id = :id");
        $this->db->bind(':id', $id);

        $row = $this->db->single();
        return $row;
    }

    // delete post
    public function deletePost($id)
    {
        $this->db->query("DELETE FROM posts WHERE id = :id");
        $this->db->bind(':id', $id);

        // Execute
        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function getReviews()
    {

        $this->db->query("SELECT * FROM reviews ORDER BY id DESC");

        $result = $this->db->resultSet();
        return $result;
    }

    public function approveReview($id)
    {
        $this->db->query("UPDATE `reviews` SET `status` = 1 WHERE id = '$id'");

        // Execute
        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function addReview($review)
    {
        $this->db->query("INSERT INTO `reviews`(`name`, `comment`, `rating`, `status`) VALUES (:name,:comment,:rating,:status)");
        $this->db->bind(':name', $review['name']);
        $this->db->bind(':comment', $review['comment']);
        $this->db->bind(':rating', $review['rating']);
        $this->db->bind(':status', $review['status']);
        // Execute
        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function deleteReview($id)
    {
        $this->db->query("DELETE FROM reviews WHERE id = :id");
        $this->db->bind(':id', $id);

        // Execute
        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }
}
