<?php

use App\libraries\Database;

class User
{
    private $db;

    public function __construct()
    {
        $this->db = new Database;
    }

    public function getUsers()
    {
        $this->db->query("SELECT * FROM users");

        $result = $this->db->resultSet();
        return $result;
    }

    public function register($data)
    {
        $this->db->query('INSERT INTO users (username, email, password, confirm_password) VALUES (
            :username, :email, :password, :confirm_password
        )');

        $this->db->bind(':username', $data['username']);
        $this->db->bind(':email', $data['email']);
        $this->db->bind(':password', $data['password']);
        $this->db->bind(':confirm_password', $data['confirm_password']);

        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function login($username, $password)
    {
        $this->db->query('SELECT * FROM users WHERE username = :username');
        $this->db->bind(':username', $username);
        $row = $this->db->single();
        $hashedPassword =  $row->password;

        if (password_verify($password, $hashedPassword)) {
            return $row;
        } else {
            return false;
        }
    }

    public function findUserByEmail($email)
    {
        $this->db->query('SELECT * FROM users WHERE email = :email');

        $this->db->bind(':email', $email);

        if ($this->db->rowCount() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function updatePassword($errors)
    {
        $password = $errors['password'];
        $confirm_password = $errors['passwordConfirm'];
        $email = $errors['email'];
        $this->db->query("UPDATE `users` SET `password`='$password',`confirm_password`='$confirm_password' WHERE email='$email'");

        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function deleteKey($errors)
    {
        $this->db->query('DELETE FROM password_reset_temp WHERE email = :email');

        $this->db->bind(':email', $errors['email']);

        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function insertToken($email, $key, $expDate)
    {
        $this->db->query("INSERT INTO `password_reset_temp`(`email`, `key`, `expDate`) VALUES ('$email','$key','$expDate')");
        if ($this->db->execute()) {
            return true;
        } else {
            return false;
        }
    }

    public function getKey($email, $key)
    {
        $this->db->query("SELECT * FROM password_reset_temp WHERE `email` = '$email' AND `key` = '$key'");
        $result = $this->db->resultSet();
        return $result;
    }
}
