<?php
require ROOT . '/views/includes/header.php';
?>
<div class="container-fluid p-5">
    <div class="row mt-5">
        <div class="col text-center">
            <?php echo $data["success"]; ?>
            <h3>Book for Accomodation</h3>
            <p>Worldwide accomodation bookings, executive accommodation, private houses, bedspace, lodges,
                shared accommodation, hostels, backpackers</p>
        </div>
    </div>
    <div class="row my-5">
        <div class="col">
            <form method="post">
                <div class="form-row">
                    <div class="col-md-6 mb-3">
                        <label for="validationDefault01">Name</label>
                        <input type="text" name="visitor_name" class="form-control" id="validationDefault01" value="Mark" required>
                    </div>
                    <div class="col-md-6 mb-3">
                        <label for="validationDefault02">Email</label>
                        <input type="text" name="visitor_email" class="form-control" id="validationDefault02" value="name@mail.com" required>
                    </div>
                </div>
                <div class="form-row">
                    <div class="col-md-6 mb-3">
                        <label for="validationDefault01">Country</label>
                        <input type="text" name="visitor_country" class="form-control" id="validationDefault01" value="Zimbabwe" required>
                    </div>
                    <div class="col-md-6 mb-3">
                        <label for="validationDefault02">Phone</label>
                        <input type="text" name="visitor_phone" class="form-control" id="validationDefault02" value="000-000-000" required>
                    </div>
                </div>
                <div class="form-row">
                    <div class="col-md-6 mb-3">
                        <label for="validationDefault03">City</label>
                        <input type="text" class="form-control" name="visitor_city" id="validationDefault03" value="Harare" required>
                    </div>
                    <div class="col-md-3 mb-3">
                        <label for="validationDefault04">Adult</label>
                        <input id="adult" min="1" class="form-control" name="total_adults" placeholder="2" required="" type="number" />
                    </div>
                    <div class="col-md-3 mb-3">
                        <label for="validationDefault05">Children</label>
                        <input id="child" min="0" class="form-control" name="total_children" placeholder="2" required="" type="number" />
                    </div>
                </div>
                <div class="form-row">
                    <div class="col-md-6 mb-3">
                        <textarea id="message" name="visitor_message" placeholder="Tell us anything else that might be important." required=""></textarea>
                    </div>
                    <div class="col-md-6 mb-3">
                        <div class="form-row">
                            <div class="col-md-6 mb-6">
                                <label for="validationDefault04">Select Room Preference</label>
                                <select class="custom-select" id="validationDefault04" name="room_preference" required>
                                    <option value="">Choose a Room from the List</option>
                                    <option value="connecting">Connecting</option>
                                    <option value="adjoining">Adjoining</option>
                                    <option value="adjacent">Adjacent</option>
                                </select>
                            </div>
                            <div class="col-md-6 mb-6">
                                <div class="form-row mt-3">
                                    <div class="col-md-6 mb-6">
                                        <label for="validationDefault04">Check-in Date</label>
                                        <input id="checkin-date" class="form-control dates" name="checkin" required type="date" />
                                    </div>
                                    <div class="col-md-6 mb-6">
                                        <label for="validationDefault03">Check-out Date</label>
                                        <input id="checkout-date" class="form-control dates" name="checkout" required type="date" />
                                    </div>
                                </div>

                            </div>
                        </div>

                    </div>
                </div>
                <button class="btn btn-primary" name="btnSubmit" type="submit">Submit</button>
            </form>
        </div>
    </div>
</div>
<script type="text/javascript">
    var currentDateTime = new Date();
    var year = currentDateTime.getFullYear();
    var month = (currentDateTime.getMonth() + 1);
    var date = currentDateTime.getDate();

    if (date < 10) {
        date = '0' + date;
    }
    if (month < 10) {
        month = '0' + month;
    }

    var dateTomorrow = year + "-" + month + "-" + date;
    var checkinElem = document.querySelector("#checkin-date");
    var checkoutElem = document.querySelector("#checkout-date");

    checkinElem.setAttribute("min", dateTomorrow);

    checkinElem.onchange = function() {
        checkoutElem.setAttribute("min", this.value);
    }
</script>
<?php
require ROOT . '/views/includes/footer.php';
?>